//=============================================================================================
//Prject Name: Arduino Based nerves of steel
//Project Code: 130342-I_Nerves_of_steel
//Project created:
//Microcontroller : ATMEGA328P
//IDE :Arduino0022 supports all higher version
//Created:Elektor Elabs
//Programming Langauge: Embedded C
//The project project idea basically need to operated with arduino. 
// the game is reference A well-known dexterity game, But in a multi-player(max.4) version. the user need to win the game
//with out touching curly wire accroding to game rule is created.
//============================================================================================
#include "pitches.h"   //includes the pitches note for playing different tone 
//=============================================================================================
//Animated music
//=============================================================================================
// notes in the melody:
//player1
int melody[] = {
  NOTE_C4, NOTE_G3,NOTE_G3, NOTE_A3, NOTE_G3,0, NOTE_B3, NOTE_C4};
// note durations: 4 = quarter note, 8 = eighth note, etc.:
// Reference to notation  
int noteDurations[] = { 4, 8, 8, 4,4,4,4,4 };
  
//player2  
int melody1[]={NOTE_E7, NOTE_E7, 0, NOTE_E7, 0, NOTE_C7, NOTE_E7,0, NOTE_G7,0}; 
int noteDurations1[] ={12, 12, 12, 12,12,12,12,12,12,12 };

//player3
int melody2[]={NOTE_B4, NOTE_B5, NOTE_B2, NOTE_B6, NOTE_B3, NOTE_AS4,0,0, NOTE_C4,NOTE_F5}; 
int noteDurations2[] ={12, 12, 12, 12, 12, 12, 6, 3, 12, 12};

//player4
int melody3[]={NOTE_AS4, NOTE_A2, NOTE_AS3,NOTE_A4, NOTE_FS4, NOTE_GS3, NOTE_AS3,NOTE_G3, NOTE_F4,NOTE_E3}; 
int noteDurations3[] ={4, 4, 4, 8,8,4,4,4,4,4 };
  
//==========================================================================================
//winner tone for theme based tone for 50 sec ,repeat loop as per requirment
int finalwinner[] = {
  NOTE_G4,NOTE_G4,NO_SOUND,NOTE_G4,NOTE_G4,NO_SOUND,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_G4,
   NOTE_B3,NOTE_G3,NOTE_C4,NOTE_G3,NOTE_CS4,NOTE_G3,NOTE_C4,NOTE_G3,NOTE_B3,NOTE_G3,NOTE_C4,NOTE_G3,NOTE_CS4,NOTE_G3,NOTE_C4,NOTE_G3,
   NOTE_E4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_E4,NOTE_E4,NOTE_E4,
   NOTE_E4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_E4,NOTE_E4,NOTE_E4,
   //Introduction
/*  NOTE_E4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_E4,NOTE_E4,NOTE_E4,
  NOTE_E4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_E4,NOTE_E4,NOTE_E4,
  NOTE_E4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_F4,NOTE_E4,NOTE_E4,NOTE_E4,
  NOTE_E4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_E4,NOTE_E4,NOTE_E4,
  NOTE_DS5,NOTE_D5,NOTE_B4,NOTE_A4,NOTE_B4,
  NOTE_E4,NOTE_G4,NOTE_DS5,NOTE_D5,NOTE_G4,NOTE_B4,
  NOTE_B4,NOTE_FS5,NOTE_F5,NOTE_B4,NOTE_D5,NOTE_AS5,
  NOTE_A5,NOTE_F5,NOTE_A5,NOTE_DS6,NOTE_D6,NO_SOUND*/
};
  
int noteDurationswinner[] = {
  8,8,2,8,8,2,16,8,16,8,8,
   2,4,2,4,2,4,2,4,2,4,2,4,2,4,2,4,
   8,16,16,8,4,8,8,8,
   8,16,16,8,4,8,8,8
/*  8,16,16,8,4,8,8,8,
  8,16,16,8,4,8,8,8,
  8,16,16,8,4,8,8,8,
  8,16,16,8,4,8,8,8,
  8,2,8,8,1,
  8,4,8,4,8,8,
  8,8,4,8,4,8,
  4,8,4,8,3 */
};  
  
int pace = 1450; // change pace of music("speedy") 

// setup mode for configuraton to INPUT and OUTPUT operation
// Configuration as per Datasheet microcontroller ATMEGA328P 
 
//==========================================================================================
void setup(){
  
  pinMode(2,INPUT);               //ring for player1
  digitalWrite(2,HIGH);
  pinMode(13, OUTPUT);            //fault idnetification for player1
  
  pinMode(3,INPUT);              //ring for player 2
  digitalWrite(3,HIGH);
  pinMode(12,OUTPUT);            //fault idnetification for player2
  
  
  pinMode(6,INPUT);              //ring for player 3
  digitalWrite(6,HIGH);
  pinMode(11,OUTPUT);            //fault idnetification for player3
  
  pinMode(4,INPUT);              //ring for player 4
  digitalWrite(4,HIGH);
  pinMode(10,OUTPUT);            //fault idnetification for player1
  
// winner Defination setup for players    
//==========================================================================
  pinMode(8,INPUT);        //winner 1 
  digitalWrite(8,HIGH);
  pinMode(A0,OUTPUT);               //for example case
  digitalWrite(A0,HIGH);
//==========================================================================
    pinMode(9,INPUT);       //winner 2
    digitalWrite(9,HIGH);
 //   pinMode(A1,OUTPUT);
 //   digitalWrite(A1,HIGH);
//===================================================    
                            //winner 3
    pinMode(A4,INPUT);
    digitalWrite(A4,HIGH);
    pinMode(A0,OUTPUT);
    digitalWrite(A0,HIGH);
//=============================================    
    pinMode(A5,INPUT);        //winner 4
    digitalWrite(A5,HIGH);
    pinMode(A0,OUTPUT);
    digitalWrite(A0,LOW);
//=============================================== 
//startgame();       // for to indicate continues blink green LED 
  

}

void loop(){
  
    startgame();                 // for to indicate continues blink green LED 
 //========================================================================= 
 int sensorVal = digitalRead(2);  //check the status of ring 1
  if (sensorVal == HIGH) {        //TRUE 
    digitalWrite(10, LOW);
    
  }
  else {                            
    digitalWrite(10, HIGH);          // player corresponding LED blink
    player1();                       //playing tone function to player 1
    //  finalwinner1();
   // digitalToggle(13);
  }
  
//===========================================================================

int sensorval1 = digitalRead(3);    //check the status of ring 2
if(sensorval1 == HIGH)               //TRUE
  { 
    digitalWrite(11,LOW);
  }
  else {  
         digitalWrite(11,HIGH);           // player corresponding LED blink
         player2();                        //playing tone function to player 2
        
       }
//==============================================================================  
int sensorval11 = digitalRead(6);      //check the status of ring 3
if(sensorval11 == HIGH)                  //TRUE
  { 
    digitalWrite(12,LOW);
  }
  else {
         
         digitalWrite(12,HIGH);           // player corresponding LED blink
         player3();                        //playing tone function to player 3
         
       }
//==============================================================================
int sensorval12 = digitalRead(4);                //check the status of ring 4
if(sensorval12 == HIGH)                            //TRUE
  { 
    digitalWrite(13,LOW);
  }
  else {
         digitalWrite(13,HIGH);                  // player corresponding LED blink
         player4();                             //playing tone function to player 4
       }
//==============================================================================

int winner = digitalRead(9);                      //check the status of winner logic

  if(winner == HIGH)                               //true
  {
    // digitalWrite(A0,HIGH);
     
     finalwinner1();                             //play winner tone at Buzzer and blink green led 
   //  digitalWrite(10,HIGH);
  }else
  {
   //  digitalWrite(A0,LOW);                      //commented
     
  }

int winner1 = digitalRead(8);                  //check the status of winner logic

  if(winner1 == HIGH)                          //true
  {
    // digitalWrite(A0,HIGH);
    
     finalwinner2();                           //play winner tone at Buzzer and blink green led 
   //   digitalWrite(11,HIGH);
     
  }else
  {
    // digitalWrite(A0,LOW);                   //commented
   //  digitalWrite(11,LOW);
  }
 

int winner2 = digitalRead(A4);                 //check the status of winner logic

  if(winner2 == HIGH)                           //true
  {
    // digitalWrite(A0,HIGH);
    
     finalwinner3();                          //play winner tone at Buzzer and blink green led 
    //  digitalWrite(12,HIGH);
  }else
  {
   //  digitalWrite(A0,LOW);
    // digitalWrite(12,LOW);                 //commented
  }

int winner3 = digitalRead(A5);                 //check the status of winner logic

  if(winner3 == HIGH)                           //true
  {
   //  digitalWrite(A0,HIGH);
   
     finalwinner4();                          //play winner tone at Buzzer and blink green led 
    //   digitalWrite(13,HIGH);
  }else
  {
   //  digitalWrite(A0,LOW);
   //  digitalWrite(13,LOW);                 //commented
  }
 
}

//===============================================================================
void player1()                                            //player 1 tone will generate at the buzzer when ring touch the curly wire
{
  for (int thisNote = 0; thisNote < 8; thisNote++) {
      blow();
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[thisNote];
    tone(7, melody[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 0.05;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(7);
  }
}
//=============================================================================
void player2()                                                //player 2 tone will generate at the buzzer when ring touch the curly wire
{
    for (int thisNote = 0; thisNote < 10; thisNote++) {
     blow();
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations1[thisNote];
    tone(7, melody1[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 0.05;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(7);
  }
}
//=============================================================================
void player3()                                                //player 3 tone will generate at the buzzer when ring touch the curly wire
{
    for (int thisNote = 0; thisNote < 10; thisNote++) {
     blow();
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations2[thisNote];
    tone(7, melody2[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 0.05;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(7);
  }
}
//=============================================================================
void player4()                                            //player 4 tone will generate at the buzzer when ring touch the curly wire
{
    for (int thisNote = 0; thisNote < 10; thisNote++) {
    blow();
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations3[thisNote];
    tone(7, melody3[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 0.05;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(7);
  }
}
//==========================================================================

void finalwinner1()
{
  
   digitalWrite(A0,HIGH);
   for (int Note = 0; Note <15; Note++) {//counter of Notes (54 limit the array)
   
  // DDRB |= 0b00000100;
  // PORTB = ~PORTB;
  // delay(10);
  
  digitalWrite(10,HIGH);digitalWrite(A0,HIGH);
  delay(5);
  digitalWrite(10,LOW);digitalWrite(A0,LOW);
  delay(5);
   
   
    int duration = 1000/noteDurationswinner[Note];//Adjust duration with the pace of music
    tone(7, finalwinner[Note],duration); //Play note
// to distinguish the notes, set a minimum time between them.
    delay(duration*0.08);
    noTone(7);
  }
   
   digitalWrite(A0,LOW);
   delay(10);
   while(1)
   {
     digitalWrite(A0,HIGH);         //winner status logic indication
     digitalWrite(10,HIGH);
     //delay(100);
   }
}
//==========================================================================

void finalwinner2()
{
  
   digitalWrite(A0,HIGH);
   for (int Note = 0; Note <15; Note++) {//counter of Notes (54 limit the array)
   
 //  DDRB |= 0b00001000;
 //  PORTB = ~PORTB;
 //  delay(10);
   
   digitalWrite(11,HIGH);digitalWrite(A0,HIGH);
  delay(5);
  digitalWrite(11,LOW);digitalWrite(A0,LOW);
  delay(5);
   
    int duration = 1000/noteDurationswinner[Note];//Adjust duration with the pace of music
    tone(7, finalwinner[Note],duration); //Play note
// to distinguish the notes, set a minimum time between them.
    delay(duration*0.08);
    noTone(7);
  }
   
   while(1)
   {
     digitalWrite(A0,HIGH);
     digitalWrite(11,HIGH);              //winner status logic indication
     //delay(100);
   }
}
//==========================================================================

void finalwinner3()
{
  
   digitalWrite(A0,HIGH);
   for (int Note = 0; Note <15; Note++) {//counter of Notes (54 limit the array)
   
 //  DDRB |= 0b00010000;
 //  PORTB = ~PORTB;
 //  delay(10);
   digitalWrite(12,HIGH);digitalWrite(A0,HIGH);
  delay(5);
  digitalWrite(12,LOW);digitalWrite(A0,LOW);
  delay(5);
   
    int duration = 1000/noteDurationswinner[Note];//Adjust duration with the pace of music
    tone(7, finalwinner[Note],duration); //Play note
// to distinguish the notes, set a minimum time between them.
    delay(duration*0.08);
    noTone(7);
  }
  
   
   digitalWrite(A0,LOW);
   delay(10);
   while(1)
   {
     digitalWrite(A0,HIGH);
     digitalWrite(12,HIGH);                    //winner status logic indication
     //delay(100);
   }
}
//==========================================================================

void finalwinner4()
{
  
   digitalWrite(A0,HIGH);
   for (int Note = 0; Note <15; Note++) {//counter of Notes (54 limit the array)
   
  // DDRB |= 0b00100000;
  // PORTB = ~PORTB;
  // delay(10);
   digitalWrite(13,HIGH);digitalWrite(A0,HIGH);
  delay(5);
  digitalWrite(13,LOW);digitalWrite(A0,LOW);
  delay(5);
   
    int duration = 1000/noteDurationswinner[Note];//Adjust duration with the pace of music
    tone(7, finalwinner[Note],duration); //Play note
// to distinguish the notes, set a minimum time between them.
    delay(duration*0.08);
    noTone(7);
  }
   
   digitalWrite(A0,LOW);
   delay(10);
   while(1)
   {
     digitalWrite(A0,HIGH);
     digitalWrite(13,HIGH);                  //winner status logic indication
     //delay(100);
   }
}
//==========================================================================
void startgame()
{
                                // for continues blinking LED when start function call 
  digitalWrite(A0,HIGH);        //led is on
  delay(5);                      //5ms delay between on and off status 
  digitalWrite(A0,LOW);          // LED is off
  delay(5);                      //5ms delay between on and off status 
  
}
//==============================================================================
//having variation delay for GREEN LED glow as per player touch the wire.
void blow()                    //for looping the led operation 
{                                // for continues blinking LED when start function call
     digitalWrite(A0,HIGH);          //led is on
     delay(2);                       //2ms delay between on and off status
     digitalWrite(A0,LOW);             // LED is off
     delay(2);                 //5ms delay between on and off status
}
//=============================================================================
